package com.prolog.eis.service.out;


import com.prolog.eis.model.outbound.PrintScheme;
import com.prolog.framework.core.restriction.Criteria;

import java.util.List;
import java.util.Map;

/**
 * @author zmr
 * @description: 打印机模块-服务接口类
 * @date 2023-08-30 12:24
 */
public interface PrintSchemeService {

    /**
     * 新增数据
     *
     * @param printScheme 打印机模块
     */
    long save(PrintScheme printScheme);

    /**
     * 新增批量数据
     *
     * @param printSchemeList 打印机模块
     */
    long saveBatch(List<PrintScheme> printSchemeList);

    /**
     * 查询多条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象列表
     */
    List<PrintScheme> findByMap(Map<String, Object> paramMap);

    /**
     * 查询单条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象
     */
    PrintScheme findOneByMap(Map<String, Object> paramMap);

    /**
     * 查询多条数据
     *
     * @param criteria 查询起始位置
     * @return 对象列表
     */
    List<PrintScheme> findByCriteria(Criteria criteria);

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrintScheme findById(int id);

    /**
     * 修改数据
     *
     * @param printScheme 实例对象
     */
    long update(PrintScheme printScheme);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     */
    long deleteById(int id);

    /**
     * 通过参数删除数据
     *
     * @param paramMap 参数
     */
    long deleteByMap(Map<String, Object> paramMap);

    /**
     * 通过参数查询总条数
     *
     * @param paramMap 参数
     */
    long findCountByMap(Map<String, Object> paramMap);

}
